package applixml;

import java.io.*;
import java.util.*;
import java.lang.*;

public class Token
{

    // Accidents
    public Hashtable caracAccident;
    public Hashtable tableAccident = new Hashtable();
    public Vector idAccident = new Vector (); 

    // Batiments
    public Hashtable caracBatiment;
    public Hashtable tableBatiment = new Hashtable();
    public Vector idBatiment = new Vector (); 

    // Routes
    public Hashtable caracRoute;
    public Hashtable tableRoute = new Hashtable();
    public Vector idRoute = new Vector (); 

    public Token (String nomFichier1, String nomFichier2, String nomFichier3, String nomFichier4, String nomFichier5, String nomFichier6) throws Exception
    {
	tokenAccident (nomFichier1, nomFichier2);
	tokenBatiment (nomFichier3, nomFichier4);
	tokenRoute (nomFichier5, nomFichier6);
    }

    /*
     * Recuperer les accidents
     */

    void tokenAccident (String nomFichier1, String nomFichier2) throws Exception
    {
        BufferedReader in1 = new BufferedReader(new FileReader(nomFichier1));
        BufferedReader in2 = new BufferedReader(new FileReader(nomFichier2));
	String lu = "";
	int nombreLignesAccident = 0;

	// Les attributs de l'accident
	String id = "";
	String nombrePersonnes = "";
	String lieu = "";
	String localisation = "";

	System.out.print ("Getting accidents from files " + nomFichier1 + " and " + nomFichier1);
	while (lu != null)
	    {
		nombreLignesAccident++;
		
		// Lecture du premier fichier : les lieux des accidents
		lu = in1.readLine () ;
		switch (nombreLignesAccident % 5)
		    {
			// Nouvel accident
		    case 1 : caracAccident = new Hashtable ();
			break;

			// id de l'accident
		    case 2 : id = lu;
			idAccident.addElement (id);
			break;
		    
			// Nombre de personne impliquees dans l'accident
		    case 3 : nombrePersonnes = lu;
			break;

			// lieu de l'accident
		    case 4 : lieu = lu;
			break;
			
			// localisation de l'accident
		    case 0 : localisation = lu;

			/*
			 * Fin des caracteristiques de l'accident -> on met
			 * toutes les infos dans la table de hashage
			 */
			
			caracAccident.put("id", id);
			caracAccident.put("nombrePersonnes", nombrePersonnes);
			caracAccident.put("lieu", lieu);
			caracAccident.put("localisation", localisation);
			
			// Lecture du second fichier : les regions de l'accident
			
			// Le type de region (P, R ou L)
			lu = in2.readLine () ;
			caracAccident.put ("type", lu);

			// Le nombre de points de la region
			lu = in2.readLine () ;

			int nombrePoints = Integer.parseInt(lu);

			/*
			 * Les coordonnees de chaque point sont rangees dans
			 * deux vector : X pour les abscisses et Y pour les
			 * ordonnees
			 */
			
			Vector X = new Vector ();
			Vector Y = new Vector ();

			for (int i=0; i < nombrePoints; i++)
			    {
				lu = in2.readLine () ;

				X.addElement (lu.substring(0, lu.indexOf (" ")));
				Y.addElement (lu.substring(lu.indexOf (" ") + 1, lu.length()));
			    }
			caracAccident.put("X", X);
			caracAccident.put("Y", Y);

			tableAccident.put(id, caracAccident);

			break;
		    }
	    }
	System.out.println (" done.");
    }

    /*
     * Recuperer les batiments
     */

    void tokenBatiment (String nomFichier1, String nomFichier2) throws Exception
    {
        BufferedReader in1 = new BufferedReader(new FileReader(nomFichier1));
        BufferedReader in2 = new BufferedReader(new FileReader(nomFichier2));
	String lu = "";
	int nombreLignesBatiment = 0;

	// Les attributs du batiment
	String id = "";
	String couleur = "";
	String type = "";
	String nomVille = "";
	String CP = "";

	System.out.print ("Getting buildings from files " + nomFichier1 + " and " + nomFichier1);
	while (lu != null)
	    {
		nombreLignesBatiment++;

		// DOM prend trop de memoire -> on ne fait que les 1000 premiers
		if (nombreLignesBatiment == 6000) break ;
		
		// Lecture du premier fichier : les lieux des batiments
		lu = in1.readLine () ;
		switch (nombreLignesBatiment % 6)
		    {
			// Nouveau batiment
		    case 1 : caracBatiment = new Hashtable ();
			break;

			// id du batiment
		    case 2 : id = lu;

			idBatiment.addElement (id);
			break;
		    
			// couleur du batiment
		    case 3 : couleur = lu;
			break;

			// type de batiment
		    case 4 : type = lu;
			break;

			// Nom de la ville du batiment
		    case 5 : nomVille = lu;
			break;

			// Code Postal de la ville du batiment
		    case 0 : CP = lu;

			/*
			 * Fin des caracteristiques du batiment -> on met
			 * toutes les infos dans la table de hashage
			 */
			
			caracBatiment.put("id", id);
			caracBatiment.put("couleur", couleur);
			caracBatiment.put("type", type);
			caracBatiment.put("nomVille", nomVille);
			caracBatiment.put("CP", CP);
			
			// Lecture du second fichier : les regions du batiment
			
			// Le type de region (P, R ou L)
			lu = in2.readLine () ;
			caracBatiment.put ("type", lu);

			// Le nombre de points de la region
			lu = in2.readLine () ;
			int nombrePoints = Integer.parseInt(lu);

			/*
			 * Les coordonnees de chaque point sont rangees dans
			 * deux vector : X pour les abscisses et Y pour les
			 * ordonnees
			 */
			
			Vector X = new Vector ();
			Vector Y = new Vector ();
			
			for (int i=0; i < nombrePoints; i++)
			    {
				lu = in2.readLine () ;

				X.addElement (lu.substring(0, lu.indexOf (" ")));
				Y.addElement (lu.substring(lu.indexOf (" ") + 1, lu.length()));
			    }
			caracBatiment.put("X", X);
			caracBatiment.put("Y", Y);

			tableBatiment.put(id, caracBatiment);

			break;
		    }
	    }
	System.out.println (" done.");
    }

    /*
     * Recuperer les routes
     */

    void tokenRoute (String nomFichier1, String nomFichier2) throws Exception
    {
        BufferedReader in1 = new BufferedReader(new FileReader(nomFichier1));
        BufferedReader in2 = new BufferedReader(new FileReader(nomFichier2));
	String lu = "";
	int NombreRoute = 0;

	// Les attributs de la route
	String nombreRoutes = "";
	String id = "";
	String debit = "";
	String type = "";
	String distance = "";
	
	System.out.print ("Getting roads from files " + nomFichier1 + " and " + nomFichier1);
	while (lu != null)
	    {
		NombreRoute++;
		
		// Lecture du premier fichier : les villes des routes
		lu = in1.readLine () ;
		switch (NombreRoute % 5)
		    {
			// Nouvelle route
		    case 1 : caracRoute = new Hashtable ();
			break;

			// id de la route
		    case 2 : id = lu;
			idRoute.addElement (id);
			break;
		    
			// debit de la route
		    case 3 : debit = lu;
			break;

			// type de route
		    case 4 : type = lu;
			break;
			
			// distance de la route
		    case 0 : distance = lu;

			/*
			 * Fin des caracteristiques de la route -> on met
			 * toutes les infos dans la table de hashage
			 */
			
			caracRoute.put("id", id);
			caracRoute.put("debit", debit);
			caracRoute.put("type", type);
			caracRoute.put("distance", distance);
			
			// Lecture du second fichier : les regions de la route
			
			// Le type de region (P, R ou L)
			lu = in2.readLine () ;
			caracRoute.put ("type", lu);

			// Le nombre de points de la region
			lu = in2.readLine () ;
			int nombrePoints = Integer.parseInt(lu);
						
			/*
			 * Les coordonnees de chaque point sont rangees dans
			 * deux vector : X pour les abscisses et Y pour les
			 * ordonnees
			 */
			
			Vector X = new Vector ();
			Vector Y = new Vector ();
			
			for (int i=0; i < nombrePoints; i++)
			    {
				lu = in2.readLine () ;

				X.addElement (lu.substring(0, lu.indexOf (" ")));
				Y.addElement (lu.substring(lu.indexOf (" ") + 1, lu.length()));
			    }
			caracRoute.put("X", X);
			caracRoute.put("Y", Y);

			tableRoute.put(id, caracRoute);

			break;
		    }
	    }
	System.out.println (" done.");
    }
}
