package applixml;

import java.io.File;
import org.xml.sax.*;
import java.io.IOException;
import java.util.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.io.FileOutputStream;
import org.apache.xml.serialize.XMLSerializer;
import org.apache.xml.serialize.OutputFormat;

/**
 * Insrez la description du type ici.
 * Date de cration : (05/03/02 19:58:48)
 * @author: Administrator
 */
public class XmlToTxt {
    Document doc;
    /**
     * Commentaire relatif au constructeur XmlToTxt.
     */
    public XmlToTxt(String nomFic) {
	try{
	    DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	    DocumentBuilder builder = factory.newDocumentBuilder();
	    //On cre un nouveau document xml
	    this.doc = builder.parse(nomFic);
	    
	}catch(Exception e){
	    e.printStackTrace();
	}
	
	
    }

    /**
     * Methode renvoyant un vecteur contenant les attributs de toutes les villes
     * @return java.util.Vector
     */
    public Hashtable convertToXml() {
	// Racine du document
	Element docRoot = this.doc.getDocumentElement();
	
	// Hashtable contenant le document XML: cls :"accident", "route", "batiment"
	Hashtable tableFinale = new Hashtable();
	
	// Vecteur contenant la liste des villes
//	 listenoeuds = new Vector();
	
	// Table de hashage contenant les attributs pour 1 ville
	Hashtable attributVille;
	
	// Vecteur contenant les coordonnes de la ville
	Vector point = new Vector();
	
	// Liste contient la liste des villes
	NodeList liste = docRoot.getChildNodes();
	
	for(int i = 0; i < liste.getLength(); i++){
	    // Noeud
	    Node ville = liste.item(i);
	    boolean exist = false;
	    
	    attributVille = new Hashtable();
	    
	    // listAttribut est la liste des attributs de cette ville
	    NodeList listAttribut = ville.getChildNodes();
	    
	    for(int j = 0; j < listAttribut.getLength(); j++){
		
		// On recupere la valeurs de chaque attributs et on les range dans la table de hashage	
			if(listAttribut.item(j).hasChildNodes()){
		    	exist = true;
		   // System.out.println ("Balise lue : " + listAttribut.item(j).getNodeName());
		    if(listAttribut.item(j).getNodeName().equals("id")){
				attributVille.put("id", listAttribut.item(j).getFirstChild().getNodeValue());
	   		 }
	    	else if(listAttribut.item(j).getNodeName().equals("nombrePersonnes")){
				attributVille.put("nombrePersonnes", listAttribut.item(j).getFirstChild().getNodeValue());
	    	}
	    	else if(listAttribut.item(j).getNodeName().equals("lieu")){
				attributVille.put("lieu", listAttribut.item(j).getFirstChild().getNodeValue());
		    }
		    else if(listAttribut.item(j).getNodeName().equals("localisation")){
				attributVille.put("localisation", listAttribut.item(j).getFirstChild().getNodeValue());
		    }
		    else if(listAttribut.item(j).getNodeName().equals("couleur")){
				attributVille.put("couleur", listAttribut.item(j).getFirstChild().getNodeValue());
			    }
		    else if(listAttribut.item(j).getNodeName().equals("type")){
				attributVille.put("type", listAttribut.item(j).getFirstChild().getNodeValue());
		    }
		    else if(listAttribut.item(j).getNodeName().equals("nomVille")){
				attributVille.put("nomVille", listAttribut.item(j).getFirstChild().getNodeValue());
		    }
		    else if(listAttribut.item(j).getNodeName().equals("CP")){
				attributVille.put("CP", listAttribut.item(j).getFirstChild().getNodeValue());
		    }
		    else if(listAttribut.item(j).getNodeName().equals("debit")){
				attributVille.put("debit", listAttribut.item(j).getFirstChild().getNodeValue());
		    }
		    else if(listAttribut.item(j).getNodeName().equals("distance")){
				attributVille.put("distance", listAttribut.item(j).getFirstChild().getNodeValue());
		    }
		    else if(listAttribut.item(j).getNodeName().equals("nuage") || listAttribut.item(j).getNodeName().equals("region") || listAttribut.item(j).getNodeName().equals("ligne")){
				attributVille.put("geo", listAttribut.item(j).getNodeName());
			
			// listPoint est la liste des coordonnes de cette ville
				NodeList listPoint = listAttribut.item(j).getChildNodes();
				point = new Vector();
				
				for(int k = 0; k < listPoint.getLength(); k++){
		  			if(listPoint.item(k).getNodeName().equals("point")){
						point.addElement(listPoint.item(k).getAttributes().getNamedItem("x").getNodeValue());
						point.addElement(listPoint.item(k).getAttributes().getNamedItem("y").getNodeValue());	
					}
				}
			
			attributVille.put("point", point);
					
		    }
			}
	    }
	    if(exist){
		    tableFinale.put(ville.getNodeName() + attributVille.get("id"), attributVille);
//		listenoeuds.addElement(attributVille);
	    }
	}
	
	return tableFinale;
    }
}
