package applixml;

import java.io.File;
import org.xml.sax.*;
import java.io.IOException;
import java.util.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import java.io.FileOutputStream;
import org.apache.xml.serialize.XMLSerializer;
import org.apache.xml.serialize.OutputFormat;


public class txtToXml{
    Document doc;
    
    /**
     * Methode permettant d'ecrire un document doc dans le fichier de
     * sortie fic
     * @param tableVille Hashtable
     * @param ListeVille Vector
     */
    public txtToXml(Hashtable tableAccident, Vector idAccident, Hashtable tableBatiment, Vector idBatiment, Hashtable tableRoute, Vector idRoute, String NomFichier)
    {
	System.out.println ("Now building tree...");
	try{
	    DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	    DocumentBuilder builder = factory.newDocumentBuilder();
	    
	    // On cre un nouveau document xml
	    
	    this.doc = builder.newDocument();
	    
	    // Element racine du document : cartes
	    Element docRoot = doc.createElement("cartes");
	    doc.appendChild(docRoot);

	    // Les accidents
	    System.out.print ("Adding accidents to tree");
	    Accident (doc, docRoot, tableAccident, idAccident);
	    System.out.println (" done.");

	    // Les batiments
	    System.out.print ("Adding buildings to tree");
	    Batiment (doc, docRoot, tableBatiment, idBatiment);
	    System.out.println (" done.");

	    // Les routes
	    System.out.print ("Adding roads to tree");
	    Route (doc, docRoot, tableRoute, idRoute);
	    System.out.println (" done.");
	    
	    // On sauvegarde le fichier dans fic
	    System.out.print ("Writing output file : " + NomFichier);
	    ecritFichier(doc, NomFichier);
	    System.out.println (" done.");	    
	}
	catch (ParserConfigurationException e)
	    {
		e.printStackTrace();
	    }
    }
    
    void Accident (Document doc, Element docRoot, Hashtable tableAccident, Vector idAccident)
    {
	
	//On parcourt toutes les villes releves dans la table de hashage tableAccident
	for(int i = 0; i < tableAccident.size(); i++){
				// On rcupre les caractristiques de chaque accident et on les insere dans le document
	    Hashtable caracteristiques = (Hashtable) tableAccident.get(idAccident.elementAt(i));
	    
				// On cree une balise accident pour chaque accident
	    Element accident = doc.createElement("accident");
	    docRoot.appendChild(accident);
	    
	    // On insere dans la balise accident chaque caractristiques
	    // lues dans la table de hashage caracteristiques
	    
	    // id de l'accident
	    Element id = doc.createElement("id");
	    id.appendChild(doc.createTextNode((String)caracteristiques.get("id")));
	    accident.appendChild(id);
	    
	    // Nombre de personnes impliquees dans l'accident
	    Element nombrePersonnes = doc.createElement("nombrePersonnes");
	    nombrePersonnes.appendChild(doc.createTextNode((String) caracteristiques.get("nombrePersonnes")));
	    accident.appendChild(nombrePersonnes);
	    
	    // Lieu de l'accident
	    Element lieu = doc.createElement("lieu");
	    lieu.appendChild(doc.createTextNode((String)caracteristiques.get("lieu")));
	    accident.appendChild(lieu);
	    
	    // Localisation de l'accident
	    Element	localisation = doc.createElement("localisation");
	    localisation.appendChild(doc.createTextNode((String)caracteristiques.get("localisation")));
	    accident.appendChild(localisation);
	    
	    // Geographie de l'accident
	    geo (doc, accident, caracteristiques);
	    
	}
    }
    
    void Batiment (Document doc, Element docRoot, Hashtable tableBatiment, Vector idBatiment)
    {
	// On parcourt touts les accidents releves dans la table
	// de hashage tablebatiment
	for(int i = 0; i < tableBatiment.size(); i++){
				// On rcupre les caractristiques de chaque accident et on les insere dans le document
	    Hashtable caracteristiques = (Hashtable) tableBatiment.get(idBatiment.elementAt(i));
	    
				// On cree une balise accident pour chaque batiment
	    Element batiment = doc.createElement("batiment");
	    docRoot.appendChild(batiment);
	    
	    // On insere dans la balise batiment chaque caractristiques
	    // lues dans la table de hashage caracteristiques
	    
	    // id du batiment
	    Element id = doc.createElement("id");
	    id.appendChild(doc.createTextNode((String)caracteristiques.get("id")));
	    batiment.appendChild(id);
	    
	    // Couleur du batiment
	    Element couleur = doc.createElement("couleur");
	    couleur.appendChild(doc.createTextNode((String) caracteristiques.get("couleur")));
	    batiment.appendChild(couleur);
	    
	    // Type du batiment
	    Element type = doc.createElement("type");
	    type.appendChild(doc.createTextNode((String)caracteristiques.get("type")));
	    batiment.appendChild(type);
	    
	    // Nom de la ville ou se trouve le batiment
	    Element nomVille = doc.createElement("nomVille");
	    nomVille.appendChild(doc.createTextNode((String)caracteristiques.get("nomVille")));
	    batiment.appendChild(nomVille);

	    // Code Postal de la ville ou se trouve le batiment
	    Element cp = doc.createElement("CP");
	    cp.appendChild(doc.createTextNode((String)caracteristiques.get("CP")));
	    batiment.appendChild(cp);
	    
	    // Geographie du batiment
	    geo (doc, batiment, caracteristiques);
	    
	}
	
    }

    void Route (Document doc, Element docRoot, Hashtable tableRoute, Vector idRoute)
    {
	// On parcourt toutes les routes relevees dans la table de
	// hashage tableRoute
	for(int i = 0; i < tableRoute.size(); i++){
				// On rcupre les caractristiques de chaque route et on les insere dans le document
	    Hashtable caracteristiques = (Hashtable) tableRoute.get(idRoute.elementAt(i));
	    
				// On cree une balise route pour chaque route
	    Element route = doc.createElement("route");
	    docRoot.appendChild(route);
	    
	    // On insere dans la balise route chaque caractristiques
	    // lues dans la table de hashage caracteristiques
	    
	    // id de la route
	    Element id = doc.createElement("id");
	    id.appendChild(doc.createTextNode((String)caracteristiques.get("id")));
	    route.appendChild(id);
	    
	    // Debit de la route
	    Element debit = doc.createElement("debit");
	    debit.appendChild(doc.createTextNode((String) caracteristiques.get("debit")));
	    route.appendChild(debit);
	    
	    // Type de la route
	    Element type = doc.createElement("type");
	    type.appendChild(doc.createTextNode((String)caracteristiques.get("type")));
	    route.appendChild(type);
	    
	    // Distance de la route
	    Element distance = doc.createElement("distance");
	    distance.appendChild(doc.createTextNode((String)caracteristiques.get("distance")));
	    route.appendChild(distance);
	    
	    // Geographie de la route
	    geo (doc, route, caracteristiques);

	}
    }
    
    void geo (Document doc, Element el, Hashtable caracteristiques)
    {
	Element typeGeo = null;
	
	if (caracteristiques.get("type").equals ("R"))
	    {
		typeGeo = doc.createElement ("region");
	    }
	else if (caracteristiques.get("type").equals ("L"))
	    {
		typeGeo = doc.createElement ("ligne");
	    }
	else if (caracteristiques.get("type").equals ("P"))
	    {
		typeGeo = doc.createElement ("nuage");
	    }
	else
	    {
		System.err.println ("Erreur : type de region non reconnu : " + caracteristiques.get("type"));
	    }
	
	
				//Element typeGeo = doc.createElement((String) caracteristiques.get("Type"));
	Vector X = new Vector();
	Vector Y = new Vector();
	
	X = (Vector) caracteristiques.get("X");
	Y = (Vector) caracteristiques.get("Y");
	
				//On cre un lment point qui aura comme attributs les coordonnes de la ville	
	for(int j = 0; j < X.size(); j++){
	    Element point = doc.createElement("point");
	    point.setAttribute("x", (String) X.elementAt(j));
	    point.setAttribute("y", (String) Y.elementAt(j));
	    typeGeo.appendChild(point);
	}
	
	el.appendChild(typeGeo);
    }

    /**
     * Methode permettant d'ecrire un document doc dans le fichier de sortie fic
     * @param doc org.w3c.dom.Document
     * @param fic java.lang.String
     */
    public void ecritFichier(Document doc, String fic) {
	OutputFormat outf = new OutputFormat();
	outf.setIndent(0);
	outf.setIndenting(true);
	outf.setEncoding("ISO-8859-1");
	outf.setDoctype (null, "carte.dtd"); 
	try {                          
	    XMLSerializer xmls = new XMLSerializer(new FileOutputStream(fic),outf);
  	    xmls.serialize(doc);
	}
	catch ( Exception e ) {
	    System.out.println("XMLGenerator : error "+e);
	}
    }
}
