
import	java.io.*;
import	java.util.*;

public class FilesWriter implements Cloneable
{
protected FileOutputStream reportFileStream= null;
protected PrintWriter      reportWriter    = null;
protected String           outFileName;

public FilesWriter(String ofn)
  {
    outFileName		=	ofn;
  }
  /**
   *  Open the files that the reports will be written to
   *  during this test run. Called automatically by the
   *  constructor. Any re-call will re-open the files for
   *  writing, causing the previous file to be overwritten.
   **/
public void open ()
  {
    // Try to close the files if they are already open
    close();

    // Now try to open the files
    try
      {
	reportFileStream = new FileOutputStream (outFileName);
	reportWriter = new PrintWriter (reportFileStream, true);
      }
    catch (Exception e)
      {
	// Cannot create the file, so set it to null
	reportFileStream = null;
	e.printStackTrace();
      }
  }

  /**
   *  Close the files that the reports have been written
   *  to during the test run. Call once per run.
   *  Automatically called when the application closes.
   **/

public void close()
  {
    try
      {
	if (reportFileStream != null)
	  reportFileStream.close();
      }
    catch (IOException e)
      {
	e.printStackTrace();
	// Do nothing - will not occur if the files have opened successfully
      }
  }
public PrintWriter	out()
  {
    return reportWriter;
  }

  // usage du FilesWriter
public static void main(String args[])
  {
    String	fileName	=	"nomFichier";
    FilesWriter	writer	=	new	FilesWriter(fileName);
    System.out.println("Ouverture du fichier :" + fileName);
    writer.open();
    (writer.out()).println("donne  inclure");
    writer.close();
  }
  // fin de FilesWriter
}
