import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;


public class Svg extends DefaultHandler
{
    static private Writer  out;
    String zone = ""; // Le type de zone

    static String fileName = "";
    static FilesWriter writer;

    boolean Mod1000 = true;
    //    boolean Mod1000 = false;

    private void emit(String s) throws SAXException
    {
	(writer.out()).print(s);
    }


    // Saute une ligne
    private void nl() throws SAXException
    {
	String lineEnd =  System.getProperty("line.separator");
	(writer.out()).println(lineEnd);
    }

    // Dbut de la lecture du document
    public void startDocument() throws SAXException
    {
	emit("<?xml version='1.0' encoding='UTF-8'?>\n");
	emit ("<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 20001102//EN\"\n");
	emit ("  \"http://www.w3.org/TR/2000/CR-SVG-20001102/DTD/svg-20001102.dtd\">\n");
	emit ("<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"600\" height=\"600\">");
	nl();
    }


    // Fin de la lecture du document
    public void endDocument() throws SAXException
    {
	try
	    {
		emit ("\n</svg>");
		nl();
		out.flush();
	    }
	catch (IOException e)
	    {
		throw new SAXException("I/O error", e);
	    }
    }


    // Dbut d'une balise
    public void startElement(String namespaceURI, String lName, String qName,
			     Attributes attrs) throws SAXException
    {
	String eName = lName;  // nom de l'lment
	if ("".equals(eName))
	    eName = qName;  // namespaceAware = false

	if ((eName.equals ("region")) || (eName.equals ("ligne")) || (eName.equals ("nuage")) || (eName.equals ("point")))
	    {
		if ((!eName.equals ("point")) && (zone.equals ("regionDebut"))) // plus de point de region a lire
		    {
			zone = "";
			emit ("\"\n         style=\"stroke-width:10; stroke-linecap:butt;\"/>\n");
			emit ("\n        </g>\n");
		    }
		if (eName.equals ("ligne"))
		    {
			zone = "ligneDebut";
			emit ("\n        <g style=\"stroke:green;\">");

			emit ("\n        <line ");
		    }
		else if (eName.equals ("region"))
		    {
			zone = "regionDebut";
			emit ("\n        <g style=\"stroke:red;\">");
			emit ("\n        <polyline points=\"");
		    }
		else if (eName.equals ("nuage"))
		    {
			zone = "nuageDebut";
			//			emit ("\n        <polyline points=\"");
		    }
		else if (eName.equals ("point"))
		    {
			if (zone.equals ("ligneDebut"))
			    {
				zone = "ligneFin";
				String aName1 = attrs.getLocalName(0);  // Nom de l'attribut
				String aName2 = attrs.getLocalName(1);  // Nom de l'attribut
				if ("".equals(aName1))
				    aName1 = attrs.getQName(0);
				if ("".equals(aName2))
				    aName2 = attrs.getQName(1);

				if ((Mod1000) && (Integer.parseInt(attrs.getValue(0)) > 1000))
					emit ("x1=\"" + Integer.parseInt(attrs.getValue(0)) % 1000+ "\" y1=\"" + Integer.parseInt(attrs.getValue(1)) % 1000 + "\"");
				else
					emit ("x1=\"" + attrs.getValue(0) + "\" y1=\"" + attrs.getValue(1) + "\"");
			    }
			else if (zone.equals ("ligneFin"))
			    {
				zone = "";
				String aName1 = attrs.getLocalName(0);  // Nom de l'attribut
				String aName2 = attrs.getLocalName(1);  // Nom de l'attribut
				if ("".equals(aName1))
				    aName1 = attrs.getQName(0);
				if ("".equals(aName2))
				    aName2 = attrs.getQName(1);

				if ((Mod1000) && (Integer.parseInt(attrs.getValue(0)) > 1000))
					emit (" x2=\"" + Integer.parseInt(attrs.getValue(0)) % 1000 + "\" y2=\"" + Integer.parseInt(attrs.getValue(1)) % 1000 + "\"\n              style=\"stroke-width:10; stroke-linecap:butt;\"/>\n");
				else
					emit (" x2=\"" + attrs.getValue(0) + "\" y2=\"" + attrs.getValue(1) + "\"\n              style=\"stroke-width:10; stroke-linecap:butt;\"/>\n");
				emit ("        </g>\n");
			    }
			else if (zone.equals ("regionDebut"))
			    {
				String aName1 = attrs.getLocalName(0);  // Nom de l'attribut
				String aName2 = attrs.getLocalName(1);  // Nom de l'attribut
				if ("".equals(aName1))
				    aName1 = attrs.getQName(0);
				if ("".equals(aName2))
				    aName2 = attrs.getQName(1);

				if ((Mod1000) && (Integer.parseInt(attrs.getValue(0)) > 1000))
					emit (Integer.parseInt(attrs.getValue(0)) % 1000 + "," + Integer.parseInt(attrs.getValue(1)) % 1000 + " ");
				else
					emit (attrs.getValue(0) + "," + attrs.getValue(1) + " ");
			    }
			else if (zone.equals ("nuageDebut"))
			    {
				String aName1 = attrs.getLocalName(0);  // Nom de l'attribut
				String aName2 = attrs.getLocalName(1);  // Nom de l'attribut
				if ("".equals(aName1))
				    aName1 = attrs.getQName(0);
				if ("".equals(aName2))
				    aName2 = attrs.getQName(1);
				
				emit ("\n        <g style=\"stroke:blue;\">");
				emit ("\n        <rect ");
				int x = Integer.parseInt(attrs.getValue(0));
				int y = Integer.parseInt(attrs.getValue(1));

				if ((Mod1000) && (Integer.parseInt(attrs.getValue(0)) > 1000))
				    {
					x = x % 1000;
					y = y % 1000;
				    }
				emit ("x=\"" + x + "\" y=\"" + y + "\" width=\"1\" height=\"1\"\n              style=\"stroke-width:10; stroke-linecap:butt;\"/>\n");
				emit ("        </g>\n");
			    }
		    }
	    
	    }
    }
	     
    // Fin de la balise
    public void endElement(String namespaceURI, String sName, String qName)
	throws SAXException
    {
    }

    // Programme principal
    public static void main(String argv[])
    {
	if (argv.length < 1)
	    {
		System.err.println("Usage : cmd nom_de_fichier.xml [-OUT <fic SVG>]");
		System.exit(1);
	    }

	// Le fichier de sortie peut etre specifie en argument (-OUT <ficSVG>)
	for (int i=0; i<argv.length; i++)
	    {
		if (argv[i].equals ("-OUT"))
		    {
			fileName = argv[i+1];
		    }
	    }

	if (fileName.equals (""))
	    {
		fileName = "carte.svg";
	    }

	writer = new FilesWriter(fileName);        
	// Nouveau manipulateur SAX
	DefaultHandler handler = new Svg();

	// Utilise le parser SAX par dfaut (non validant)
	SAXParserFactory factory = SAXParserFactory.newInstance();
	try
	    {
		writer.open();

		// Initialisation du flux de sortie
		out = new OutputStreamWriter(System.out, "UTF8");

		// Parcours du fichier d'entre
		SAXParser saxParser = factory.newSAXParser();
		saxParser.parse( new File(argv[0]), handler);

		writer.close();
	    }
	catch (Throwable t)
	    {
		t.printStackTrace();
	    }
	System.exit(0);
    }
}
